﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.9
@EndOfDesignText@
'https://edencoding.com/javafx-charts/
Sub Class_Globals
'	Private fx As JFX
	Dim nativeMe, pc As JavaObject                                'pc holds the Pie Chart object
	Public Legend_Side_Left As String = "Left"                    'set the Legend position to the LEFT of the Pie Chart
	Public Legend_Side_Right As String = "Right"                  'set the Legend position to the RIGHT of the Pie Chart
	Public Legend_Side_Top As String = "Top"                      'set the Legend position to the TOP of the Pie Chart
	Public Legend_Side_Bottom As String = "Bottom"                'set the Legend position to the BOTTOM of the Pie Chart
	
End Sub

'Initializes the piechart object
Public Sub Initialize
	
	nativeMe = Me                                                 'initialize an instance of the Pie Chart object

End Sub

'Get the pie chart instance - you should add it to a pane
public Sub drawPieChart() As JavaObject
	
	pc = nativeMe.RunMethod("DrawChart", Null)
	Return pc
	
End Sub

'Set the title of the pie chart
public Sub setTitle(title As String)
	
	nativeMe.RunMethod("setTitle", Array(title))
	
End Sub

'Show the crosshair (True or False)
Public Sub setShowCrossHair (show As Boolean)
	
	nativeMe.RunMethod("setShowCrossHair", Array(show))
	
End Sub

'Set the starting angle of the pie chart
public Sub setStartAngle (startangle As Int)
	
	nativeMe.RunMethod("setStartAngle", Array(startangle))
	
End Sub

'Set the visibility of the labels of the pie chart slices
Public Sub setLabelsVisible(labelsVisible As Boolean)
	
	nativeMe.RunMethod("setLabelsVisible", Array(labelsVisible))
	
End Sub

'Set the visibility of the legend
Public Sub setLegendVisible(legendVisible As Boolean)
	
	nativeMe.RunMethod("setLegendVisible", Array(legendVisible))
	
End Sub

'Set the visibility of the legend
Public Sub setLabelLineLength(labelLineLength As Float)
	
	nativeMe.RunMethod("setLabelLineLength", Array(labelLineLength))
	
End Sub

'draw the pie chart clockwise / anti-clockwise
Public Sub setClockwise(clockwise As Boolean)
	
	nativeMe.RunMethod("setClockwise", Array(clockwise))
	
End Sub

'Set the position of the Legend (it can be LEFT, RIGHT, TOP, BOTTOM)
public Sub setLegendSide(whatside As String)
	
	nativeMe.RunMethod("setLegendSide", Array(whatside))
	
End Sub

'add a slice to the Pie Chart by passing the slice name and slice value
public Sub addData(name As String, value As Float)
	
	nativeMe.RunMethod("addData", Array(name, value))
	
End Sub

'remove a slice by making use of the slice index (first slice added will be index 0 - etc)
public Sub removeSliceByIndex(indexno As Int)
	
	nativeMe.RunMethod("removeSliceByIndex", Array(indexno))
	
End Sub


'callback is called from the inline Java code -> ba.raiseEventFromUI(this, "callback", mylist);
Private Sub callback (mylist As Object)
	
	CallSubDelayed2(Main,"PieChart_Value_Clicked", mylist)    'call/raise event in PieChartValueClicked of module Main
															  'see the "ba.raiseEventFromUI(this, "callback", mylist);" in the inline java code
End Sub

'INLINE JAVA CODE BELOW

#if Java

//START OF IMPORTS
import javafx.scene.chart.*;
import javafx.geometry.Side;
import javafx.scene.control.Label;
import javafx.event.EventHandler;
import javafx.scene.input.MouseEvent;
import javafx.scene.control.Label;
import javafx.scene.paint.Color;
import javafx.scene.text.Text;
import java.util.*;
import javafx.scene.*;
import javafx.scene.chart.XYChart.*;
import javafx.scene.chart.PieChart.Data;

import javafx.collections.FXCollections;            
import javafx.collections.ObservableList;
//END OF IMPORTS

//DECLARING VARIABLES
private static BA ba;
private ObservableList<Data> pieChartData = FXCollections.observableArrayList();
private PieChart piechart = new PieChart(pieChartData);


    //add the Pie Chart labels
	private static String[] xvals;
	public void setPieLabels(String[] xvals) {
		this.xvals = xvals;
	}
    
	//add the Pie Chart title
	private static String title = "";
	public void setTitle(String title) {
		this.title = title;
		if (piechart != null)	                                      //if the piechart object != null then we can change the start angle of the fly
			piechart.setTitle(title);				
	}

	//add the values of the Pie Chart slices
	private static float[] yvals;
	public void setPieValues(float[] yvals) {
		this.yvals = yvals;
	}
	
	//show or don't show the crosshair
	private static boolean showcrosshair = false;
	public void setShowCrossHair(boolean showcrosshair) {
		this.showcrosshair = showcrosshair;
		if (piechart != null)	                                      //if the piechart object != null then we can change the start angle of the fly
			piechart.setCursor(Cursor.CROSSHAIR);		
	}		
	
	//set the starting angle of the first Pie Chart slice
	private static int startangle = 90;
	public void setStartAngle(int startangle) {
		this.startangle = startangle;		
		if (piechart != null)	                                      //if the piechart object != null then we can change the start angle of the fly
			piechart.setStartAngle(startangle);
	}
	
	//show or don't show the labels of the Pie Chart slices
	private static boolean labelsVisible = true;
	public void setLabelsVisible(boolean labelsVisible) {
		this.labelsVisible = labelsVisible;
		if (piechart != null)                                         //if the piechart object != null then we can change the label visibility of the fly
			piechart.setLabelsVisible(labelsVisible);
	}
	
	//show or don't show the Pie Chart Legend
	private static boolean legendVisible = true;
	public void setLegendVisible(boolean legendVisible) {
		this.legendVisible = legendVisible;
		if (piechart != null)                                          //if the piechart object != null then we can change the visibility of the Legend of the fly
			piechart.setLegendVisible(legendVisible);
	}	
	
	//set the line length extending from the slices to their lables
	private static float labelLineLength = 15.0f;
	public void setLabelLineLength(float labelLineLength) {
		this.labelLineLength = labelLineLength;
		if (piechart != null)                                          //if the piechart object != null then we can change the label length of the fly
			piechart.setLabelLineLength(labelLineLength);		
	}		
	
	//draw the Pie Chart clockwise or anti-clockwse
	private static boolean clockwise = true;
	public void setClockwise(boolean clockwise) {
		this.clockwise = clockwise;
		if (piechart != null)                                          //if the piechart object != null then we can change the clockwise/anti-clockwise direction of the fly                      
			piechart.setClockwise(clockwise);
	}
	
	//what side to put the Pie Chart Legend (LEFT, RIGHT, TOP, BOTTOM)
	private static String whatside = "Left";
	public void setLegendSide(String whatside) {
		this.whatside = whatside;		
		
		if ((piechart != null) & (whatside.equals("Left")))            //if the piechart object != null then we can change the position of the fly
			piechart.setLegendSide(Side.LEFT);                         //set the Legend to the LEFT of the Pie Chart
		if ((piechart != null) & (whatside.equals("Right")))
			piechart.setLegendSide(Side.RIGHT);	                       //set the Legend to the RIGHT of the Pie Chart		
		if ((piechart != null) & (whatside.equals("Top")))
			piechart.setLegendSide(Side.TOP);	                       //set the Legend to the TOP of the Pie Chart
		if ((piechart != null) & (whatside.equals("Bottom")))
			piechart.setLegendSide(Side.BOTTOM);		               //set the Legend to the BOTTOM of the Pie Chart			
	}	
	


	//return the Pie Chart object - set all attributes first have been set
	public PieChart DrawChart() {
		return piechart;
    }

    public void naiveAddData(String name, float value) {
        pieChartData.add(new javafx.scene.chart.PieChart.Data(name, value));
		addMouseEvent();
    }

    //updates existing Data-Object if name matches
    public void addData(String name, float value) {
        for(javafx.scene.chart.PieChart.Data d : pieChartData) {
            if(d.getName().equals(name)) {
                d.setPieValue(value);
                return;
            }
        }
        naiveAddData(name, value);
    }
	
	//add a mouse_pressed event to the pie chart - the event will return the label and value of the slice that was clicked
	private void addMouseEvent() {
		for (final PieChart.Data data : piechart.getData()) {                           //add a MOUSE_PRESSED event to the Pie Chart
		    data.getNode().addEventHandler(MouseEvent.MOUSE_PRESSED,                    //it will get/return the name and value of the slice clicked on via the "callback" event
		        new EventHandler<MouseEvent>() {
		            @Override public void handle(MouseEvent e) {
						List<Object> mylist = new ArrayList<>();                        //create an ArrayList that will be used to return data to "callback"
						mylist.add(data.getName());                                     //add the name of the pie slice clicked on
						mylist.add(String.valueOf(data.getPieValue()));                 //add the value of the pie slice clicked on
						mylist.add(e.getSceneX());                                      //add the X position of the pie slice clicked on
						mylist.add(e.getSceneY());                                      //add the Y position of the pie slice clicked on
						ba.raiseEventFromUI(this, "callback", mylist);	                //pass the ArrayList to the "callback" method in the B4J code - it will be received as an Object in the B4J code and then raise an event in module Main
						//ba.raiseEventFromUI(this, EventName.toLowerCase(BA.cul) + "_fire", 10);
		             }
		        });
		}		
	}
	
	//remove a slice by making use of the slice index (first slice added will be index 0 - etc)
	public void removeSliceByIndex(int seriesno) {
		piechart.getData().remove(seriesno);
	}		

#End If





